/* File modClient.c */
/*
 ##############################################################
 # (C) 2015 BAE SYSTEMS
 #
 # ECOA GimmeGimmeGimme (Client-Server) Sample
 #
 # $Id: modClient.c,v 1.11 2016/07/19 20:25:31 ksappleb Exp $
 #
 # Part of the BAE Systems, Rochester, ECOA Samples collection
 #
 # Created by K S Appleby, BAE Systems, Airport Works, Rochester, Kent
 #
 # This software is developed for and on behalf of BAE Systems (Operations)
 # Limited, Dassault Aviation, Bull SAS, Thales Systmes Aroports,
 # AgustaWestland Limited, GE Aviation Systems Limited,
 # General Dynamics United Kingdom Limited and Selex ES Ltd.,
 # and the copyright is owned by BAE Systems (Operations) Limited,
 # Dassault Aviation, Bull SAS, Thales Systmes Aroports, AgustaWestland
 # Limited, GE Aviation Systems Limited, General Dynamics United Kingdom
 # Limited and Selex ES Ltd.
 #
 # This software is developed by BAE Systems (Operations)
 # Limited, Electronic Systems, and is the Intellectual
 # Property of BAE Systems (Operations) Limited, Electronic Systems.
 #
 # The information set out in this document is provided solely
 # on an as is basis and the co-developers of this software make
 # no warranties expressed or implied, including no warranties
 # as to completeness, accuracy or fitness for purpose, with respect
 # to any of the information.
 ##############################################################
*/
#include "modClient.h"

#include <stdio.h>

/* Runtime lifecycle API */
void modClient__INITIALIZE__received
   (modClient__context* context)
{
//	printf( "modClient__INITIALIZE__received\n" );
   /* User Code Here */
}

void modClient__START__received
   (modClient__context* context)
{
//	printf( "modClient__START__received\n" );
	modClient_container__INITIALIZE__Ticker( context );
}

void modClient__STOP__received
   (modClient__context* context)
{
   /* User Code Here */
}

void modClient__SHUTDOWN__received
   (modClient__context* context)
{
   /* User Code Here */
}

void modClient__REINITIALIZE__received
   (modClient__context* context)
{
   /* User Code Here */
}

void modClient__Tick__received
   (modClient__context* context)
{
	ECOA__int32 IAm;
	ECOA__return_status errc = ECOA__return_status_OK;
	sql__string requestStmt, responseData;
	//
	fflush(stdout); // Make sure that any piped IO is completed
	//
//	printf( "modClient__Tick__received\n" );
	modClient_container__get_Id_value( context, &IAm );
	responseData.current_size = 0;
	//
	requestStmt.current_size = sprintf( requestStmt.data, "select * from iTable where %c = %d;", (IAm==1?'A':'B'), context->user.Count++ );
	printf( "Request: %s\n", requestStmt.data );
	errc = modClient_container__Gimme__request_sync( context, &requestStmt, &responseData );
	if( errc != ECOA__return_status_OK ){
		printf( "Gimme request failed with errc = %ld\n", (long)errc );
	}else{
		responseData.data[responseData.current_size] = '\000'; // responseData is NOT zero terminated. Make it so...
		printf( "Response: %s\n", responseData.data );
	}
}

void modClient__service_availability_changed
   (modClient__context* context,
    modClient_container__reference_id instance,
    ECOA__boolean8 available)
{
   /* User Code Here */
}

void modClient__service_provider_changed
   (modClient__context* context,
    modClient_container__reference_id instance)
{
   /* User Code Here */
}

void modClient__lifecycle_notification__Ticker
   (modClient__context* context,
    ECOA__module_states_type previous_state,
    ECOA__module_states_type new_state)
{
	ECOA__int32     IAm;
	ECOA__log       msg;
	//
	modClient_container__get_Id_value( context, &IAm );
	//
	if( previous_state == ECOA__module_states_type_IDLE && new_state == ECOA__module_states_type_READY ){
		modClient_container__START__Ticker( context );
	}
}

