/* File modServer.c */
/*
 ##############################################################
 # (C) 2015 BAE SYSTEMS
 #
 # ECOA GimmeGimmeGimme (Client-Server) Sample
 #
 # $Id: modServer.c,v 1.8 2016/07/19 20:25:31 ksappleb Exp $
 #
 # Part of the BAE Systems, Rochester, ECOA Samples collection
 #
 # Created by K S Appleby, BAE Systems, Airport Works, Rochester, Kent
 #
 # This software is developed for and on behalf of BAE Systems (Operations)
 # Limited, Dassault Aviation, Bull SAS, Thales Systmes Aroports,
 # AgustaWestland Limited, GE Aviation Systems Limited,
 # General Dynamics United Kingdom Limited and Selex ES Ltd.,
 # and the copyright is owned by BAE Systems (Operations) Limited,
 # Dassault Aviation, Bull SAS, Thales Systmes Aroports, AgustaWestland
 # Limited, GE Aviation Systems Limited, General Dynamics United Kingdom
 # Limited and Selex ES Ltd.
 #
 # This software is developed by BAE Systems (Operations)
 # Limited, Electronic Systems, and is the Intellectual
 # Property of BAE Systems (Operations) Limited, Electronic Systems.
 #
 # The information set out in this document is provided solely
 # on an as is basis and the co-developers of this software make
 # no warranties expressed or implied, including no warranties
 # as to completeness, accuracy or fitness for purpose, with respect
 # to any of the information.
 ##############################################################
*/
#include "modServer.h"

#include <stdio.h>

/* Runtime lifecycle API */
void modServer__INITIALIZE__received
   (modServer__context* context)
{
//	printf( "modServer__INITIALIZE__received\n" );
	context->user.count = 0;
}

void modServer__START__received
   (modServer__context* context)
{
	ECOA__return_status erc;
	//
	printf( "Server is running...\n" );
	erc = modServer_container__set_service_availability( context, modServer_container__service_id__svc_Gimme, ECOA__TRUE );
}

void modServer__STOP__received
   (modServer__context* context)
{
   /* User Code Here */
}

void modServer__SHUTDOWN__received
   (modServer__context* context)
{
   /* User Code Here */
}

void modServer__REINITIALIZE__received
   (modServer__context* context)
{
   /* User Code Here */
}

void modServer__Gimme__request_received
   (modServer__context* context,
    const ECOA__uint32 ID,
    const sql__string* statement)
{
	ECOA__char8 src;
	ECOA__int32 value;
	sql__string data;
	//
//	printf( "modServer__Gimme__request_received\n" );
	// For now, respond any old rubbish... ish.
	sscanf( statement->data, "select * from iTable where %c = %d", &src, &value );
	data.current_size = sprintf( data.data, "%c[%d]: %d", src, value, context->user.count++ );
	modServer_container__Gimme__response_send( context, ID, &data );
}

