/* File Philosopher_modMain_Im_user_context.h */
/*
 ##############################################################
 # (C) 2013 BAE SYSTEMS
 #
 # ECOA Dining Philosophers Sample
 #
 # $Id: Philosopher_modMain_Im_user_context.h,v 1.6 2016/07/19 20:25:14 ksappleb Exp $
 #
 # Part of the BAE Systems, Rochester, ECOA Samples collection
 #
 # Created by K S Appleby, BAE Systems, Airport Works, Rochester, Kent
 #
 # This software is developed for and on behalf of BAE Systems (Operations)
 # Limited, Dassault Aviation, Bull SAS, Thales Systmes Aroports,
 # AgustaWestland Limited, GE Aviation Systems Limited,
 # General Dynamics United Kingdom Limited and Selex ES Ltd.,
 # and the copyright is owned by BAE Systems (Operations) Limited,
 # Dassault Aviation, Bull SAS, Thales Systmes Aroports, AgustaWestland
 # Limited, GE Aviation Systems Limited, General Dynamics United Kingdom
 # Limited and Selex ES Ltd.
 #
 # This software is developed by BAE Systems (Operations)
 # Limited, Electronic Systems, and is the Intellectual
 # Property of BAE Systems (Operations) Limited, Electronic Systems.
 #
 # The information set out in this document is provided solely
 # on an as is basis and the co-developers of this software make
 # no warranties expressed or implied, including no warranties
 # as to completeness, accuracy or fitness for purpose, with respect
 # to any of the information.
 ##############################################################
*/
#if !defined(_PHILOSOPHER_MODMAIN_IM_USER_CONTEXT_H)
#define _PHILOSOPHER_MODMAIN_IM_USER_CONTEXT_H

#include "philosopher.h"

#if defined(__cplusplus)
extern "C" {
#endif /* __cplusplus */

/* User Module Context structure example */
typedef struct
{
   /* declare the User Module Context "local" data here */
	philosopher__State PhiloState;
	ECOA__hr_time      EatUntil;
	ECOA__hr_time      ThinkUntil;
	ECOA__boolean8     HaveLeftStick;
	ECOA__boolean8     HaveRightStick;

} Philosopher_modMain_Im_user_context;

/* Warm Start Module Context structure example */
typedef struct
{
   /* declare the Warm Start Module Context data here */
   int dmy;
} Philosopher_modMain_Im_warm_start_context;

#if defined(__cplusplus)
}
#endif /* __cplusplus */

#endif  /* _PHILOSOPHER_MODMAIN_IM_USER_CONTEXT_H */
