/* @file Pub_Main_Im_container.h
 * Container Interface header for Module Pub_Main_Im
 * Generated automatically from specification; do not modify here
 */

#if !defined(_PUB_MAIN_IM_CONTAINER_H)
#define _PUB_MAIN_IM_CONTAINER_H

/* Include the types from the XML types files */
#include "ECOA.h"

#include "ECOA.h"

#include "data.h"

#include "ECOA__File.h"

/* Container Types */
#include "Pub_Main_Im_container_types.h"

#include "Pub_Main_Im_user_context.h"

#if defined(__cplusplus)
extern "C" {
#endif /* __cplusplus */

/* Incomplete definition of the technical (platform-dependent) part of the context
 * (it will be defined privately by the container) */
struct Pub_Main_Im__platform_hook;

/* Module Context structure declaration */
typedef struct 
{
   /*
    * the date of the calling operation
    */
   ECOA__timestamp operation_timestamp;

   /*
    * Other container technical data will accessible through the pointer
    * defined here
    */
   struct Pub_Main_Im__platform_hook *platform_hook;

   /* the type Pub_Main_Im_user_context shall be defined by the user
    * in the Pub_Main_Im_user_context.h file to carry the module
    * implementation private data
    */
   Pub_Main_Im_user_context user;

   Pub_Main_Im_warm_start_context warm_start;

} Pub_Main_Im__context;

/* Logging and fault management services API */
void Pub_Main_Im_container__log_trace
   (Pub_Main_Im__context* context, const ECOA__log log);

void Pub_Main_Im_container__log_debug
   (Pub_Main_Im__context* context, const ECOA__log log);

void Pub_Main_Im_container__log_info
   (Pub_Main_Im__context* context, const ECOA__log log);

void Pub_Main_Im_container__log_warning
   (Pub_Main_Im__context* context, const ECOA__log log);

void Pub_Main_Im_container__raise_error
   (Pub_Main_Im__context* context, const ECOA__log log);

void Pub_Main_Im_container__raise_fatal_error
   (Pub_Main_Im__context* context, const ECOA__log log);

/* Time services API */
void Pub_Main_Im_container__get_relative_local_time
   (Pub_Main_Im__context* context, ECOA__hr_time* relative_local_time);

ECOA__return_status Pub_Main_Im_container__get_UTC_time
   (Pub_Main_Im__context* context, ECOA__global_time* utc_time);

ECOA__return_status Pub_Main_Im_container__get_absolute_system_time
   (Pub_Main_Im__context* context, ECOA__global_time* absolute_system_time);

/* Time resolution services API */
void Pub_Main_Im_container__get_relative_local_time_resolution
   (Pub_Main_Im__context* context, ECOA__duration* relative_local_time_resolution);

void Pub_Main_Im_container__get_UTC_time_resolution
   (Pub_Main_Im__context* context, ECOA__duration* utc_time_resolution);

void Pub_Main_Im_container__get_absolute_system_time_resolution
   (Pub_Main_Im__context* context, ECOA__duration* absolute_system_time_resolution);

void Pub_Main_Im_container__save_non_volatile_context
   (Pub_Main_Im__context* context);

void Pub_Main_Im_container__get_InitDataSource_value
   (Pub_Main_Im__context* context,
    ECOA__File__FileSpec* value);

void Pub_Main_Im_container__get_LogFile_value
   (Pub_Main_Im__context* context,
    ECOA__File__FileSpec* value);

void Pub_Main_Im_container__get_Update_Rate_value
   (Pub_Main_Im__context* context,
    ECOA__float32* value);

ECOA__return_status Pub_Main_Im_container__someData__get_write_access
   (Pub_Main_Im__context* context,
    Pub_Main_Im_container__someData_handle* data_handle);

ECOA__return_status Pub_Main_Im_container__someData__cancel_write_access
   (Pub_Main_Im__context* context,
    Pub_Main_Im_container__someData_handle* data_handle);

ECOA__return_status Pub_Main_Im_container__someData__publish_write_access
   (Pub_Main_Im__context* context,
    Pub_Main_Im_container__someData_handle* data_handle);

ECOA__return_status Pub_Main_Im_container__notes__get_write_access
   (Pub_Main_Im__context* context,
    Pub_Main_Im_container__notes_handle* data_handle);

ECOA__return_status Pub_Main_Im_container__notes__cancel_write_access
   (Pub_Main_Im__context* context,
    Pub_Main_Im_container__notes_handle* data_handle);

ECOA__return_status Pub_Main_Im_container__notes__publish_write_access
   (Pub_Main_Im__context* context,
    Pub_Main_Im_container__notes_handle* data_handle);

ECOA__return_status Pub_Main_Im_container__log__get_write_access
   (Pub_Main_Im__context* context,
    Pub_Main_Im_container__log_handle* data_handle);

ECOA__return_status Pub_Main_Im_container__log__cancel_write_access
   (Pub_Main_Im__context* context,
    Pub_Main_Im_container__log_handle* data_handle);

ECOA__return_status Pub_Main_Im_container__log__publish_write_access
   (Pub_Main_Im__context* context,
    Pub_Main_Im_container__log_handle* data_handle);

ECOA__return_status Pub_Main_Im_container__unusedVD__get_write_access
   (Pub_Main_Im__context* context,
    Pub_Main_Im_container__unusedVD_handle* data_handle);

ECOA__return_status Pub_Main_Im_container__unusedVD__cancel_write_access
   (Pub_Main_Im__context* context,
    Pub_Main_Im_container__unusedVD_handle* data_handle);

ECOA__return_status Pub_Main_Im_container__unusedVD__publish_write_access
   (Pub_Main_Im__context* context,
    Pub_Main_Im_container__unusedVD_handle* data_handle);

void Pub_Main_Im_container__unusedEv__send
   (Pub_Main_Im__context* context);

ECOA__return_status Pub_Main_Im_container__unusedRR__response_send
   (Pub_Main_Im__context* context,
    const ECOA__uint32 ID,
    const ECOA__int32 foo);

ECOA__return_status Pub_Main_Im_container__set_service_availability
   (Pub_Main_Im__context* context,
    Pub_Main_Im_container__service_id instance,
    ECOA__boolean8 available);

void Pub_Main_Im_container__get_lifecycle_state__Ticker
   (Pub_Main_Im__context* context,
    ECOA__module_states_type* current_state);

ECOA__return_status Pub_Main_Im_container__STOP__Ticker
   (Pub_Main_Im__context* context);

ECOA__return_status Pub_Main_Im_container__START__Ticker
   (Pub_Main_Im__context* context);

ECOA__return_status Pub_Main_Im_container__INITIALIZE__Ticker
   (Pub_Main_Im__context* context);

ECOA__return_status Pub_Main_Im_container__SHUTDOWN__Ticker
   (Pub_Main_Im__context* context);

#if defined(__cplusplus)
}
#endif /* __cplusplus */

#endif  /* _PUB_MAIN_IM_CONTAINER_H */
