/* File Sub_Main_Im.c */
/*
 ##############################################################
 # (C) 2015 BAE SYSTEMS
 #
 # ECOA PubSub (Publish-Subscribe) Sample
 #
 # $Id: Sub_Main_Im.c,v 1.7 2016/07/19 20:25:35 ksappleb Exp $
 #
 # Part of the BAE Systems, Rochester, ECOA Samples collection
 #
 # Created by K S Appleby, BAE Systems, Airport Works, Rochester, Kent
 #
 # This software is developed for and on behalf of BAE Systems (Operations)
 # Limited, Dassault Aviation, Bull SAS, Thales Systmes Aroports,
 # AgustaWestland Limited, GE Aviation Systems Limited,
 # General Dynamics United Kingdom Limited and Selex ES Ltd.,
 # and the copyright is owned by BAE Systems (Operations) Limited,
 # Dassault Aviation, Bull SAS, Thales Systmes Aroports, AgustaWestland
 # Limited, GE Aviation Systems Limited, General Dynamics United Kingdom
 # Limited and Selex ES Ltd.
 #
 # This software is developed by BAE Systems (Operations)
 # Limited, Electronic Systems, and is the Intellectual
 # Property of BAE Systems (Operations) Limited, Electronic Systems.
 #
 # The information set out in this document is provided solely
 # on an as is basis and the co-developers of this software make
 # no warranties expressed or implied, including no warranties
 # as to completeness, accuracy or fitness for purpose, with respect
 # to any of the information.
 ##############################################################
*/
#include "Sub_Main_Im.h"
#include <stdio.h>

void Sub_Main_Im__INITIALIZE__received(Sub_Main_Im__context *context)
{
   /* User Code Here */
}

void Sub_Main_Im__START__received(Sub_Main_Im__context *context)
{
	Sub_Main_Im_container__INITIALIZE__Ticker( context );
}

void Sub_Main_Im__STOP__received(Sub_Main_Im__context *context)
{
   /* User Code Here */
}

void Sub_Main_Im__SHUTDOWN__received(Sub_Main_Im__context *context)
{
   /* User Code Here */
}

void Sub_Main_Im__REINITIALIZE__received(Sub_Main_Im__context *context)
{
   /* User Code Here */
}


void Sub_Main_Im__Tick__received(Sub_Main_Im__context *context)
{
	Sub_Main_Im_container__someData_handle data_hndl;
	Sub_Main_Im_container__notes_handle notes_hndl;
	Sub_Main_Im_container__log_handle log_hndl;
	data__LogItem itm;
	//
	fflush(stdout); // Make sure that any piped IO is completed
	//
	Sub_Main_Im_container__someData__get_read_access( context, &data_hndl );
	Sub_Main_Im_container__someData__release_read_access( context, &data_hndl );
	//
	Sub_Main_Im_container__notes__get_read_access( context, &notes_hndl );
	printf( "Accessed \"%s\"\n", *(notes_hndl.data) );
	Sub_Main_Im_container__notes__release_read_access( context, &notes_hndl );
	//
	Sub_Main_Im_container__log__get_read_access( context, &log_hndl );
	itm = *(log_hndl.data);
	Sub_Main_Im_container__log__release_read_access( context, &log_hndl );
}


void Sub_Main_Im__service_availability_changed
   (Sub_Main_Im__context* context,
    Sub_Main_Im_container__reference_id instance,
    ECOA__boolean8 available)
{
   /* User Code Here */
}

void Sub_Main_Im__service_provider_changed
   (Sub_Main_Im__context* context,
    Sub_Main_Im_container__reference_id instance)
{
   /* User Code Here */
}

void Sub_Main_Im__lifecycle_notification__Ticker
   (Sub_Main_Im__context* context,
    ECOA__module_states_type previous_state,
    ECOA__module_states_type new_state)
{
	if(( previous_state == ECOA__module_states_type_IDLE )&&( new_state == ECOA__module_states_type_READY ))
		Sub_Main_Im_container__START__Ticker( context );
}

